#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>
#include <vte/vte.h>

int firsttime = 0;
int active = 0;
int preview2 = 0;
int fp;

int values[100];
GTimer *graph_time_tracker;


/* We create the dialog boxes once and keep pointers to them in static
   variables so we can reuse them. */
static GtkWidget *open_filesel = NULL;
static GtkWidget *open_infilesel = NULL;
static GtkWidget *save_filesel = NULL;
static GtkWidget *save_outfile1sel = NULL;
static GtkWidget *save_outfile2sel = NULL;
static GtkWidget *about = NULL;

/* This is the filename of the file currently being edited, in on-disk
   encoding (which may be UTF-8 or the locale's encoding). */
static gchar *current_filename = NULL;

/* This flag is set to TRUE if the file has been changed. We don't actually
   use it here, but the program could be extended to prompt to save changes. */
static gboolean file_changed = FALSE;

/* A key used to store pointers to the main window. */
static const gchar *MainWindowKey = "MainWindowKey";

/* The size of chunks to read in when opening files. */
#define BUFFER_SIZE 8192


/* Static functions. */
static void new_file (GtkWidget *main_window);
static void open_file (GtkWidget *main_window);
static void open_infile (GtkWidget *main_window);
static void save_as (GtkWidget *main_window);

static void real_open_file (GtkWidget *main_window,
			    const gchar *filename);
static void real_open_infile (GtkWidget *main_window,
			    const gchar *filename);
static void real_save_file (GtkWidget *main_window,
			    const gchar *filename);





int get_wlan_transmited ()
{
  char buffer[80];
  size_t bytes_read;
  char* match;
  int transmited;

  //obrim el fifo amb la informacio de bandwidth del ff
  if (!fp) fp = open("/tmp/piperr1", O_NONBLOCK | O_RDONLY, 0);  

  read (fp, buffer, sizeof (buffer));

  /* Locate the line that includes the video info.  */
  match = strstr (buffer, " video:");
  if (match == NULL)
    return 0;
  /* Parse the line to extrace the bandwidth.  */
  sscanf (match, " video:%dkbps", &transmited);
  return transmited;
}
	
gboolean
update_graph (GtkWidget *widget)
{
	if (active==1) {
	  /* Get the elapsed time since the timer was started */
	    	gulong dumb_API_needs_this_variable;
	      	gdouble time_elapsed = g_timer_elapsed (graph_time_tracker, &dumb_API_needs_this_variable);

	int i,flag;
  	int transmited,transmitedpersec;
	transmited = get_wlan_transmited ();
	transmitedpersec = transmited;
	for (i=0; i<100; i++) {
		if (values[i] == -1) {values[i] = transmitedpersec; flag=1; }
		else flag=0;
	}
	if (flag == 0) {	
	  for (i=0; i<100; i++) {
		values[i] = values[i+1];
		values[99] = transmitedpersec;
	  }
	}

	  
	gdk_draw_rectangle (widget->window, widget->style->black_gc, TRUE, 0, 0, widget->allocation.width, widget->allocation.height);

	for (i=0; i<100; i++) {
	  gdk_draw_rectangle (widget->window, widget->style->white_gc, TRUE, (int)(3.6*i), 240-(int)values[i], widget->allocation.width / 100, values[i]);
	}

	    /* Return true so the function will be called again; returning false removes
	     *    * this timeout function.
	     *       */
	    return TRUE;
	}
}



gboolean
expose_event_callback (GtkWidget *widget, GdkEventExpose *event, gpointer data)
{
	int i;
	for (i=0; i<100; i++) {
	  gdk_draw_rectangle (widget->window, widget->style->black_gc, TRUE, (int)(3.6*i), 240-(int)values[i], widget->allocation.width / 100, values[i]);
	}
	    return TRUE;
}


void
on_button1_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkWidget *entry = NULL;
  	GtkWidget *drawingarea1 = NULL;
	GtkWidget *combo;
	GtkWidget *toggle;
	gint active_index, v4l_index, dsp_index;
	FILE* script_file;
	gchar *gtest;
	gchar *server1, *port1, *pass1, *mountpoint1, *server2, *port2, *pass2, *mountpoint2, *localfile1, *localfile2, *inputfile;
	int mount1 = 0;
	int mount2 = 0;
	int local1 = 0;
	int local2 = 0;
	int infile = 0;
	const char*framesizes[20] = { "-x 160 -y 128", "-x 180 -y 144", "-x 256 -y 177", "-x 320 -y 240", "-x 360 -y 288", "-x 480 -y 360", "-x 512 -y 384", "-x 540 -y 432", "-x 640 -y 480", "-x 720 -y 576", "-x 160 -y 90", "-x 180 -y 101", "-x 256 -y 144", "-x 320 -y 180", "-x 360 -y 203", "-x 480 -y 270", "-x 512 -y 288", "-x 540 -y 304", "-x 640 -y 360", "-x 720 -y 405" };
	const char*framerates[5] = {"-F 25", "-F 25:2", "-F 25:3", "-F 25:4", "-F 25:5"};	
	const int samplerates[4] = {11025, 22050, 44100, 48000};
	const char*v4ldevs[4] = {"/dev/video0","/dev/video1","/dev/video2"};
	const char*dspdevs[4] = {"/dev/dsp","/dev/dsp0","/dev/dsp1","/dev/dsp2"};
	const int inputframerates[10] = {5, 7, 10, 12, 15, 20, 24, 25, 29, 30};
		
	int i;
	for (i=0; i<100; i++) {
	  values[i]=-1;
	}


	// s'ha de checkejar si existeix el dvgrab, si existeix el ffmpeg2theora, si existeix el oggfv, si existeix el theora_player ... si algun d'aquests falla informar en una finestra d'error
	
	
	//check de camps imprescindibles (server1 AND port1 AND pass1 AND mountpoint1) OR (server2 AND port2 AND pass2 AND mountpoint2) OR (filename) ... si no, informar en una finestra d'error
	//
	
	entry = lookup_widget(GTK_WIDGET(button), "entry39");
	server1 = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
	entry = lookup_widget(GTK_WIDGET(button), "entry40");
	port1 = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
	entry = lookup_widget(GTK_WIDGET(button), "entry41");
	mountpoint1 = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
	entry = lookup_widget(GTK_WIDGET(button), "entry42");
	pass1 = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
	
	entry = lookup_widget(GTK_WIDGET(button), "entry54");
	server2 = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
	entry = lookup_widget(GTK_WIDGET(button), "entry55");
	port2 = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
	entry = lookup_widget(GTK_WIDGET(button), "entry56");
	mountpoint2 = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
	entry = lookup_widget(GTK_WIDGET(button), "entry57");
	pass2 = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);

	entry = lookup_widget(GTK_WIDGET(button), "entry80");
	localfile1= gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
	entry = lookup_widget(GTK_WIDGET(button), "entry81");
	localfile2= gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
	entry = lookup_widget(GTK_WIDGET(button), "entry82");
	inputfile= gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
	
	if ((strlen(server1) > 5) && (strlen(port1)  > 1) && (strlen(pass1) > 1) && (strlen(mountpoint1) > 4)) mount1 = 1;
	else mount1 = 0;	
	if ((strlen(server2) > 5) && (strlen(port2)  > 1) && (strlen(pass2) > 1) && (strlen(mountpoint2) > 4)) mount2 = 1;	
	else mount2 = 0;

	if (strlen(localfile1) > 1) local1 = 1;	
	else local1 = 0;	
	if (strlen(localfile2) > 1) local2 = 1;	
	else local2 = 0;	

	if (strlen(inputfile) > 1) infile = 1;	
	else infile = 0;	

	if (!mount1&&!mount2&&!local1&&!local2) {
		entry = lookup_widget(GTK_WIDGET(button), "statusbar1");
		  char message[256] = "";
		  strcat (message, "echo \"\n\nERROR: cannot start without any target configured.\n       For a target to be correctly configured fill ALL the icecast server fields\n       or specify a dump filename.\"");
		  char *env[] = {"PATH=/usr/bin:/bin:./usr/local/bin:/bin", NULL};
		  char *params[] = {"/bin/sh", "-c", message ,NULL};
		  vte_terminal_fork_command ((VteTerminal*)entry,"sh", params, env, NULL, FALSE, TRUE, TRUE);
		active=0;	
	}
	else {
		active=1; // flag global per saber si estem estrimejant o no


	//s'han de crear els pipes si no existeixen
	system ("mkfifo /tmp/piperr1 > /dev/null 2>&1");
	system ("mkfifo /tmp/piperr2 > /dev/null 2>&1");
	system ("mkfifo /tmp/pipe1 > /dev/null 2>&1");
	system ("mkfifo /tmp/pipe2 > /dev/null 2>&1");
	system ("mkfifo /tmp/pipe3 > /dev/null 2>&1");
	system ("mkfifo /tmp/pipe4 > /dev/null 2>&1");
	system ("mkfifo /tmp/pipe5 > /dev/null 2>&1");
	system ("mkfifo /tmp/pipe6 > /dev/null 2>&1");
	system ("mkfifo /tmp/pipe7 > /dev/null 2>&1");
	system ("mkfifo /tmp/pipe8 > /dev/null 2>&1");

	//obrim el fitxer del script	
	script_file = fopen ("/tmp/tssSTREAM", "w");
	fprintf(script_file,"#!/bin/bash\n");
	fprintf(script_file,"\n");
	fprintf(script_file,"NOW=$( date +\"%%Y%%d%%m-%%H%%M%%S\" ) \n");
	//fprintf(script_file,"set -x\n");
	fprintf(script_file,"\n\n echo \"---------- STARTING -----------\" \n\n");

	
       //depenent de quins mountpoints s'han configurat, de si s'ha o no de grabar i de si hi ha o no el theora_player haurem de crear el command del dbgrav amb 1,2,3,4 tee's ... i tb depenent d'aixo escriure una comanda per a cada pipe utilitzat 
	
	// SOURCE = DV RAW1394 DEVICE
	toggle = lookup_widget (GTK_WIDGET (button), "checkbutton3");
	if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(toggle)) ) { 
		fprintf(script_file,"dvgrab -format raw - ");
		if (mount1 || local1) fprintf(script_file," | tee -a /tmp/pipe1");
		if (mount2 || local2) fprintf(script_file," | tee -a /tmp/pipe2");
		fprintf(script_file," > /dev/null 2>&1 &\n");
	}
	//TODO autodetect v4l or v4l2 devices
	// SOURCE = V4L or V4L2 DEVICE
	toggle = lookup_widget (GTK_WIDGET (button), "checkbutton2");
	if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(toggle)) ) { 
		combo = lookup_widget (GTK_WIDGET (button), "combobox14");
		v4l_index = gtk_combo_box_get_active(GTK_COMBO_BOX(combo));
		combo = lookup_widget (GTK_WIDGET (button), "combobox15");
		dsp_index = gtk_combo_box_get_active(GTK_COMBO_BOX(combo));
		//TODO autodetect v4l or v4l2 devices
		fprintf(script_file,"ffmpeg -f oss -i %s -f video4linux2 -s cif -ac 2 -r 12 -i %s -acodec vorbis -vcodec libtheora -f ogg -  ", dspdevs[dsp_index], v4ldevs[v4l_index]);   
		if (mount1 || local1) fprintf(script_file," | tee -a /tmp/pipe1");
		if (mount2 || local2) fprintf(script_file," | tee -a /tmp/pipe2");
		fprintf(script_file," > /dev/null 2>&1 &\n");
	}
	// SOURCE = V4L or V4L2 DEVICE
	toggle = lookup_widget (GTK_WIDGET (button), "checkbutton6");
	if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(toggle)) ) { 
		//combo = lookup_widget (GTK_WIDGET (button), "combobox14");
		//v4l_index = gtk_combo_box_get_active(GTK_COMBO_BOX(combo));
		//combo = lookup_widget (GTK_WIDGET (button), "combobox15");
		//dsp_index = gtk_combo_box_get_active(GTK_COMBO_BOX(combo));
		//fprintf(script_file,"/usr/local/share/tss/bin/ffmpeg -vd %s -ad %s -target pal-vcd -  ", v4ldevs[v4l_index], dspdevs[dsp_index]);
		//TODO get bconfigured offset and size
		fprintf(script_file,"ffmpeg -f oss -i /dev/dsp -f x11grab -s cif -ac 2 -r 12 -i :0.0+10,20 -acodec vorbis -vcodec libtheora -f ogg - ");   
		if (mount1 || local1) fprintf(script_file," | tee -a /tmp/pipe1");
		if (mount2 || local2) fprintf(script_file," | tee -a /tmp/pipe2");
		fprintf(script_file," > /dev/null 2>&1 &\n");
	}
	// SOURCE = LOCAL FILE  
	toggle = lookup_widget (GTK_WIDGET (button), "checkbutton4");
	if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(toggle)) ) { 
	//	fprintf(script_file,"cat %s ", inputfile);
	//	if (mount1 || local1) fprintf(script_file," | tee -a /tmp/pipe1");
	//	if (mount2 || local2) fprintf(script_file," | tee -a /tmp/pipe2");
	//	fprintf(script_file," > /dev/null 2>&1 &\n");
		infile = 1;	
	} else infile = 0;	




	if (mount1 || local1) { 
		if (!infile) fprintf(script_file,"cat /tmp/pipe1 | ");
		
		fprintf(script_file,"/usr/bin/ffmpeg2theora ");
		if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(toggle)) ) {
			//combo = lookup_widget (GTK_WIDGET (button), "combobox14");
			//active_index = gtk_combo_box_get_active(GTK_COMBO_BOX(combo));
			//fprintf(script_file,"--v4l %s ",v4ldevs[active_index]);
			//combo = lookup_widget (GTK_WIDGET (button), "combobox15");
			//active_index = gtk_combo_box_get_active(GTK_COMBO_BOX(combo));
			//fprintf(script_file,"--inputfps %i ",inputframerates[active_index]);

		}
		entry = lookup_widget(GTK_WIDGET(button), "entry53");
		gtest = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
		fprintf(script_file,"--artist \"%s\" ",gtest); 
		entry = lookup_widget(GTK_WIDGET(button), "entry52");
		gtest = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
		fprintf(script_file,"--title \"%s\" ",gtest); 
		entry = lookup_widget(GTK_WIDGET(button), "entry51");
		gtest = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
		fprintf(script_file,"--date \"%s\" ",gtest); 
		entry = lookup_widget(GTK_WIDGET(button), "entry50");
		gtest = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
		fprintf(script_file,"--location \"%s\" ",gtest); 
		entry = lookup_widget(GTK_WIDGET(button), "entry49");
		gtest = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
		fprintf(script_file,"--organization \"%s\" ",gtest); 
		entry = lookup_widget(GTK_WIDGET(button), "entry48");
		gtest = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
		fprintf(script_file,"--copyright \"%s\" ",gtest); 
		entry = lookup_widget(GTK_WIDGET(button), "entry47");
		gtest = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
		fprintf(script_file,"--license \"%s\" ",gtest); 
		
		
		
		toggle = lookup_widget (GTK_WIDGET (button), "checkbutton3");
		if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(toggle)) ) fprintf(script_file,"-f dv "); 
		combo = lookup_widget (GTK_WIDGET (button), "combobox7");
		active_index = gtk_combo_box_get_active(GTK_COMBO_BOX(combo));
		fprintf(script_file,"%s ",framesizes[active_index]);
		combo = lookup_widget (GTK_WIDGET (button), "combobox6");
		active_index = gtk_combo_box_get_active(GTK_COMBO_BOX(combo));
		fprintf(script_file,"%s ",framerates[active_index]);
		combo = lookup_widget (GTK_WIDGET (button), "combobox5");
		active_index = gtk_combo_box_get_active(GTK_COMBO_BOX(combo));
		fprintf(script_file,"-v %i ",active_index);
		combo = lookup_widget (GTK_WIDGET (button), "combobox4");
		active_index = gtk_combo_box_get_active(GTK_COMBO_BOX(combo));
		fprintf(script_file,"-a %i ",(active_index-2));
		combo = lookup_widget (GTK_WIDGET (button), "combobox3");
		active_index = gtk_combo_box_get_active(GTK_COMBO_BOX(combo));
		fprintf(script_file,"-c %i ",active_index);
		combo = lookup_widget (GTK_WIDGET (button), "combobox2");
		active_index = gtk_combo_box_get_active(GTK_COMBO_BOX(combo));
		fprintf(script_file,"-H %i ",samplerates[active_index]);
	        //fprintf(script_file,"-o /tmp/pipe3 - 2>/tmp/piperr1 &\n");
	        fprintf(script_file,"-o /tmp/pipe3 ");
		if (!infile) fprintf(script_file,"- &\n");
		else fprintf(script_file,"%s &\n", inputfile);
		fprintf(script_file,"cat /tmp/pipe3 ");
		

		//toggle = lookup_widget (GTK_WIDGET (button), "checkbutton4");
		//if (gtk_toggle_button_get_active(GTK_CHECK_BUTTON(toggle)) ) fprintf(script_file," tee -a /tmp/pipe4 |");
		toggle = lookup_widget (GTK_WIDGET (button), "checkbutton5");
		if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(toggle)) ) fprintf(script_file,"| tee /tmp/pipe4 ");


		if (local1) fprintf(script_file," | tee %s$NOW.ogg ",localfile1);
		if (mount1) {
			fprintf(script_file," | /usr/bin/oggfwd ");

			entry = lookup_widget(GTK_WIDGET(button), "entry46");
			gtest = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
			fprintf(script_file,"-d \"%s\" ",gtest);
			entry = lookup_widget(GTK_WIDGET(button), "entry45");
			gtest = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
			fprintf(script_file,"-g \"%s\" ",gtest);
			entry = lookup_widget(GTK_WIDGET(button), "entry44");
			gtest = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
			fprintf(script_file,"-n \"%s\" ",gtest);
			entry = lookup_widget(GTK_WIDGET(button), "entry43");
			gtest = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
			fprintf(script_file,"-u \"%s\" ",gtest);


		
			entry = lookup_widget(GTK_WIDGET(button), "entry39");
			gtest = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
			fprintf(script_file,"%s ",gtest);
			entry = lookup_widget(GTK_WIDGET(button), "entry40");
			gtest = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
			fprintf(script_file,"%s ",gtest);
			entry = lookup_widget(GTK_WIDGET(button), "entry42");
			gtest = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
			fprintf(script_file,"%s ",gtest);
			entry = lookup_widget(GTK_WIDGET(button), "entry41");
			gtest = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
			fprintf(script_file,"%s ",gtest);
		}
		else fprintf(script_file," > /dev/null 2>&1 ");
		//toggle = lookup_widget (GTK_WIDGET (button), "checkbutton4");
		//if (gtk_toggle_button_get_active(GTK_CHECK_BUTTON(toggle)) )  fprintf(script_file,"cat /tmp/pipe4 | /usr/bin/tss_player&\n");
		
		toggle = lookup_widget (GTK_WIDGET (button), "checkbutton5");
		if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(toggle)) ) fprintf(script_file,"&\n\ncat /tmp/pipe4 | /usr/bin/tss_player > /dev/null 2>&1");
	
	}
	if (mount2 || local2) fprintf(script_file," & \n");
        else fprintf(script_file," \n");

	fprintf(script_file,"\n");
	
	
	
	
	toggle = lookup_widget (GTK_WIDGET (button), "checkbutton2");
	
	if (mount2 || local2) { 
		if (!infile) fprintf(script_file,"cat /tmp/pipe2 | ");
		
		fprintf(script_file,"/usr/bin/ffmpeg2theora ");

		entry = lookup_widget(GTK_WIDGET(button), "entry64");
		gtest = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
		fprintf(script_file,"--artist \"%s\" ",gtest); 
		entry = lookup_widget(GTK_WIDGET(button), "entry63");
		gtest = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
		fprintf(script_file,"--title \"%s\" ",gtest); 
		entry = lookup_widget(GTK_WIDGET(button), "entry62");
		gtest = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
		fprintf(script_file,"--date \"%s\" ",gtest); 
		entry = lookup_widget(GTK_WIDGET(button), "entry61");
		gtest = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
		fprintf(script_file,"--location \"%s\" ",gtest); 
		entry = lookup_widget(GTK_WIDGET(button), "entry60");
		gtest = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
		fprintf(script_file,"--organization \"%s\" ",gtest); 
		entry = lookup_widget(GTK_WIDGET(button), "entry59");
		gtest = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
		fprintf(script_file,"--copyright \"%s\" ",gtest); 
		entry = lookup_widget(GTK_WIDGET(button), "entry58");
		gtest = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
		fprintf(script_file,"--license \"%s\" ",gtest); 
		
		
		
		toggle = lookup_widget (GTK_WIDGET (button), "checkbutton3");
		if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(toggle)) ) fprintf(script_file,"-f dv "); 
		combo = lookup_widget (GTK_WIDGET (button), "combobox13");
		active_index = gtk_combo_box_get_active(GTK_COMBO_BOX(combo));
		fprintf(script_file,"%s ",framesizes[active_index]);
		combo = lookup_widget (GTK_WIDGET (button), "combobox12");
		active_index = gtk_combo_box_get_active(GTK_COMBO_BOX(combo));
		fprintf(script_file,"%s ",framerates[active_index]);
		combo = lookup_widget (GTK_WIDGET (button), "combobox11");
		active_index = gtk_combo_box_get_active(GTK_COMBO_BOX(combo));
		fprintf(script_file,"-v %i ",active_index);
		combo = lookup_widget (GTK_WIDGET (button), "combobox10");
		active_index = gtk_combo_box_get_active(GTK_COMBO_BOX(combo));
		fprintf(script_file,"-a %i ",(active_index-2));
		combo = lookup_widget (GTK_WIDGET (button), "combobox9");
		active_index = gtk_combo_box_get_active(GTK_COMBO_BOX(combo));
		fprintf(script_file,"-c %i ",active_index);
		combo = lookup_widget (GTK_WIDGET (button), "combobox8");
		active_index = gtk_combo_box_get_active(GTK_COMBO_BOX(combo));
		fprintf(script_file,"-H %i ",samplerates[active_index]);




				
		//fprintf(script_file,"-o /tmp/pipe6 - 2>/tmp/piperr2 &\n");
		fprintf(script_file,"-o /tmp/pipe6 ");
		if (!infile) fprintf(script_file,"- &\n");
		else fprintf(script_file,"%s &\n", inputfile);
		
		fprintf(script_file,"cat /tmp/pipe6 ");
		//if (preview2) fprintf(script_file," tee -a /tmp/pipe7 |");
		if (local2) fprintf(script_file," | tee %s$NOW.ogg ",localfile2);
		if (mount2) {
			
			fprintf(script_file," | /usr/bin/oggfwd ");


			entry = lookup_widget(GTK_WIDGET(button), "entry68");
			gtest = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
			fprintf(script_file,"-d \"%s\" ",gtest);
			entry = lookup_widget(GTK_WIDGET(button), "entry67");
			gtest = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
			fprintf(script_file,"-g \"%s\" ",gtest);
			entry = lookup_widget(GTK_WIDGET(button), "entry66");
			gtest = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
			fprintf(script_file,"-n \"%s\" ",gtest);
			entry = lookup_widget(GTK_WIDGET(button), "entry65");
			gtest = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
			fprintf(script_file,"-u \"%s\" ",gtest);




			entry = lookup_widget(GTK_WIDGET(button), "entry54");
			gtest = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
			fprintf(script_file,"%s ",gtest);
			entry = lookup_widget(GTK_WIDGET(button), "entry55");
			gtest = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
			fprintf(script_file,"%s ",gtest);
			entry = lookup_widget(GTK_WIDGET(button), "entry57");
			gtest = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
			fprintf(script_file,"%s ",gtest);
			entry = lookup_widget(GTK_WIDGET(button), "entry56");
			gtest = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
			fprintf(script_file,"%s \n",gtest);
		}
		else fprintf(script_file," > /dev/null 2>&1 \n");

		
		//if (preview2) fprintf(script_file,"cat /tmp/pipe7 | /usr/bin/tss_player&\n");
	
	}
	
	fprintf(script_file,"\n\n echo \"---------- FINISHED -----------\" \n\n");
	fclose (script_file);

	system ("chmod 777 /tmp/tssSTREAM");
	
	entry = lookup_widget(GTK_WIDGET(button), "statusbar1");
	vte_terminal_fork_command ((VteTerminal*)entry,"/tmp/tssSTREAM", NULL, NULL, NULL, FALSE, TRUE, TRUE);



		    

	if (firsttime==0) {
		  /*gtk_widget_set_size_request (drawing_area, 100, 100);*/
		  //drawingarea1 = lookup_widget(GTK_WIDGET(button), "drawingarea1");
      
		  //g_signal_connect (G_OBJECT (drawingarea1), "expose_event",  
		  //                        G_CALLBACK (expose_event_callback), NULL);
		  /* Start the graph_time_tracker timer, and connect it to the callback */
		  //graph_time_tracker = g_timer_new ();
		  /* Add a timeout to update the drawing area every 100 milliseconds or so */
		  //gint func_ref = g_timeout_add (250, update_graph, drawingarea1);
		  firsttime=1;
	}
	}
}


void
on_button2_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
  	GtkWidget *statusbar;

	active=0;
  	close (fp);
	//fp = NULL;
	//g_timer_destroy (graph_time_tracker);
	system("killall -9 cat > /dev/null 2>&1");
	system("killall -9 dvgrab > /dev/null 2>&1");
	system("killall -9 /usr/local/share/tss/bin/ffmpeg > /dev/null 2>&1");
	system("killall -9 /usr/bin/ffmpeg2theora > /dev/null 2>&1");
	system("killall -9 /usr/bin/oggfwd > /dev/null 2>&1");
	system("killall -9 /usr/bin/tss_player > /dev/null 2>&1");
	statusbar = lookup_widget(GTK_WIDGET(button), "statusbar1");
  	char *env[] = {"PATH=/usr/bin:/bin:./usr/local/bin:/bin", NULL};
  	char *params[] = {"/bin/sh", "-c", "echo \"\n\n---------- FINISHED -----------\n\n\"" ,NULL};
  	vte_terminal_fork_command ((VteTerminal*)statusbar,"sh", params, env, NULL, FALSE, TRUE, TRUE);

}






void
on_checkbutton2_toggled                (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	GtkWidget *toggle;
	
	if (togglebutton->active) { 
		toggle = lookup_widget (GTK_WIDGET (togglebutton), "checkbutton3");
		if (GTK_TOGGLE_BUTTON (toggle)->active) 
			gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(toggle),0);
		toggle = lookup_widget (GTK_WIDGET (togglebutton), "checkbutton4");
		if (GTK_TOGGLE_BUTTON (toggle)->active)
			gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(toggle),0);
		toggle = lookup_widget (GTK_WIDGET (togglebutton), "checkbutton6");
		if (GTK_TOGGLE_BUTTON (toggle)->active)
			gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(toggle),0);
	}

}


void
on_entry1_insert_text                  (GtkEditable     *editable,
                                        gchar           *new_text,
                                        gint             new_text_length,
                                        gpointer         position,
                                        gpointer         user_data)
{

	
}


void
on_entry1_changed                      (GtkEditable     *editable,
                                        gpointer         user_data)
{

}


void
on_new1_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}

void
on_open1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GtkWidget *main_window;

  main_window = lookup_widget (GTK_WIDGET (menuitem), "window1");
  open_file (main_window);
	
}


void
on_save1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GtkWidget *main_window;

  main_window = lookup_widget (GTK_WIDGET (menuitem), "window1");

  /* If the current document doesn't have a filename yet, we call save_as
     to show the file selection dialog. */
  if (current_filename == NULL)
    save_as (main_window);
  else
    real_save_file (main_window, current_filename);

}


void
on_save_as1_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GtkWidget *main_window;

  main_window = lookup_widget (GTK_WIDGET (menuitem), "window1");
  save_as (main_window);

}


void
on_quit1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
 system ("rm /tmp/tssSTREAM > /dev/null 2>&1");
 exit (0);
}


void
on_about1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GtkWidget *main_window;

  main_window = lookup_widget (GTK_WIDGET (menuitem), "window1");
  /* We use the same file selection widget each time, so first
     of all we create it if it hasn't already been created. */
  if (about == NULL)
    {
      about = create_aboutdialog1 ();
      /* Make sure the dialog doesn't disappear behind the main window. */
      gtk_window_set_transient_for (GTK_WINDOW (about), 
				    GTK_WINDOW (main_window));
    }

  /* We save a pointer to the main window inside the file selection's
     data list, so we can get it easily in the callbacks. */
  gtk_object_set_data (GTK_OBJECT (about), MainWindowKey, main_window);

  /* We make sure the dialog is visible. */
  gtk_window_present (GTK_WINDOW (about));

}



void
on_checkbutton3_toggled                (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	GtkWidget *toggle;
	
	if (togglebutton->active) { 
		toggle = lookup_widget (GTK_WIDGET (togglebutton), "checkbutton2");
		if (GTK_TOGGLE_BUTTON (toggle)->active) 
			gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(toggle),0);
		toggle = lookup_widget (GTK_WIDGET (togglebutton), "checkbutton4");
		if (GTK_TOGGLE_BUTTON (toggle)->active)
			gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(toggle),0);
		toggle = lookup_widget (GTK_WIDGET (togglebutton), "checkbutton6");
		if (GTK_TOGGLE_BUTTON (toggle)->active)
			gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(toggle),0);
	}

}


void
on_checkbutton4_toggled                (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	GtkWidget *toggle;
	
	if (togglebutton->active) { 
		toggle = lookup_widget (GTK_WIDGET (togglebutton), "checkbutton2");
		if (GTK_TOGGLE_BUTTON (toggle)->active) 
			gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(toggle),0);
		toggle = lookup_widget (GTK_WIDGET (togglebutton), "checkbutton3");
		if (GTK_TOGGLE_BUTTON (toggle)->active)
			gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(toggle),0);
		toggle = lookup_widget (GTK_WIDGET (togglebutton), "checkbutton6");
		if (GTK_TOGGLE_BUTTON (toggle)->active)
			gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(toggle),0);
	}
}

void
on_checkbutton6_toggled                (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	GtkWidget *toggle;
	
	if (togglebutton->active) { 
		toggle = lookup_widget (GTK_WIDGET (togglebutton), "checkbutton2");
		if (GTK_TOGGLE_BUTTON (toggle)->active) 
			gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(toggle),0);
		toggle = lookup_widget (GTK_WIDGET (togglebutton), "checkbutton3");
		if (GTK_TOGGLE_BUTTON (toggle)->active) 
			gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(toggle),0);
		toggle = lookup_widget (GTK_WIDGET (togglebutton), "checkbutton4");
		if (GTK_TOGGLE_BUTTON (toggle)->active)
			gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(toggle),0);
	}

}














/* This sets the window title according to the current filename. */
void
set_window_title (GtkWidget *main_window)
{
  gchar *title, *filename_utf8 = NULL;

  /* We need to convert the filename to UTF-8. */
  if (current_filename)
    filename_utf8 = g_filename_to_utf8 (current_filename, -1, NULL, NULL,
					NULL);

  title = g_strdup_printf ("tss: %s\n",
			   filename_utf8 ? g_basename (filename_utf8)
			   : "untitled");

  gtk_window_set_title (GTK_WINDOW (main_window), title);
  g_free (title);
  g_free (filename_utf8);
}


/* This creates a new document, by clearing the text widget and setting the
   current filename to NULL. */
static void
new_file (GtkWidget *main_window)
{
  GtkWidget *text, *statusbar;
  GtkTextBuffer *buffer;
  GtkTextIter start, end;

  text = lookup_widget (GTK_WIDGET (main_window), "text1");
  buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (text));
  gtk_text_buffer_get_bounds (buffer, &start, &end);
  gtk_text_buffer_delete (buffer, &start, &end);

  g_free (current_filename);
  current_filename = NULL;
  file_changed = FALSE;
  set_window_title (main_window);

  statusbar = lookup_widget (main_window, "statusbar1");
  char *env[] = {"PATH=/usr/bin:/bin:./usr/local/bin:/bin", NULL};
  char *params[] = {"/bin/sh", "-c", "\n\nNew file ... \n" ,NULL};
  vte_terminal_fork_command ((VteTerminal*)statusbar,"sh", params, env, NULL, FALSE, TRUE, TRUE);
}






/* This shows the file selection dialog to open a file. */
static void
open_infile (GtkWidget *main_window)
{
  /* We use the same file selection widget each time, so first
     of all we create it if it hasn't already been created. */
  if (open_infilesel == NULL)
    {
      open_infilesel = create_filechooserdialog3 ();
      /* Make sure the dialog doesn't disappear behind the main window. */
      gtk_window_set_transient_for (GTK_WINDOW (open_infilesel), 
				    GTK_WINDOW (main_window));
    }

  /* We save a pointer to the main window inside the file selection's
     data list, so we can get it easily in the callbacks. */
  gtk_object_set_data (GTK_OBJECT (open_infilesel), MainWindowKey, main_window);

  /* We make sure the dialog is visible. */
  gtk_window_present (GTK_WINDOW (open_infilesel));
}



/* This shows the file selection dialog to open a file. */
static void
open_file (GtkWidget *main_window)
{
  /* We use the same file selection widget each time, so first
     of all we create it if it hasn't already been created. */
  if (open_filesel == NULL)
    {
      open_filesel = create_filechooserdialog1 ();
      /* Make sure the dialog doesn't disappear behind the main window. */
      gtk_window_set_transient_for (GTK_WINDOW (open_filesel), 
				    GTK_WINDOW (main_window));
    }

  /* We save a pointer to the main window inside the file selection's
     data list, so we can get it easily in the callbacks. */
  gtk_object_set_data (GTK_OBJECT (open_filesel), MainWindowKey, main_window);

  /* We make sure the dialog is visible. */
  gtk_window_present (GTK_WINDOW (open_filesel));
}


/* This shows the file selection dialog to save a file. */
static void
save_as (GtkWidget *main_window)
{
  if (save_filesel == NULL)
    {
      save_filesel = create_filechooserdialog2 ();
      /* Make sure the dialog doesn't disappear behind the main window. */
      gtk_window_set_transient_for (GTK_WINDOW (save_filesel), 
				    GTK_WINDOW (main_window));
    }

  gtk_object_set_data (GTK_OBJECT (save_filesel), MainWindowKey, main_window);


  /* If the current document has a filename we use that as the default. */
  //if (current_filename)
  //  gtk_file_selection_set_filename (GTK_FILE_CHOOSER (save_filesel),
  //				     current_filename);

  /* We make sure the dialog is visible. */
  gtk_window_present (GTK_WINDOW (save_filesel));
}

void
on_button5_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_hide (gtk_widget_get_toplevel (GTK_WIDGET (button)));

}


void
on_button6_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *filesel, *main_window;
  const gchar *filename;

  filesel = gtk_widget_get_toplevel (GTK_WIDGET (button));
  main_window = gtk_object_get_data (GTK_OBJECT (filesel), MainWindowKey);
  if (gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (filesel)) != NULL ) {
  	gtk_widget_hide (filesel);
  	filename = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (filesel));
  	real_open_file (main_window, filename);
  }

}


void
on_button7_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_hide (gtk_widget_get_toplevel (GTK_WIDGET (button)));

}


/*exit from the "save as" menu */
void
on_button8_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *filesel, *main_window;
  const gchar *filename;

  filesel = gtk_widget_get_toplevel (GTK_WIDGET (button));
  main_window = gtk_object_get_data (GTK_OBJECT (filesel), MainWindowKey);
  if (gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (filesel)) != NULL ) {
  	gtk_widget_hide (filesel);
  	filename = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (filesel));
  	real_save_file (main_window, filename);
  }

}




/* This loads the given file, which is in on-disk encoding (which may not
   be UTF-8). */
static void
real_open_infile (GtkWidget *main_window, const gchar *filename)
{
  GtkWidget *entry;
  GtkWidget *toggle;
  gchar data[BUFFER_SIZE];
  gint pos=0;

    entry = lookup_widget(GTK_WIDGET(main_window), "entry82");
    gtk_editable_delete_text(GTK_EDITABLE(entry), 0, -1);
    gtk_editable_insert_text(GTK_EDITABLE(entry), filename, strlen(filename), &pos);

    toggle = lookup_widget (GTK_WIDGET (main_window), "checkbutton4");
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(toggle),1);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(toggle),1);
}






/* This loads the given file, which is in on-disk encoding (which may not
   be UTF-8). */
static void
real_open_file (GtkWidget *main_window, const gchar *filename)
{
  GtkWidget *entry, *statusbar;
  FILE *fpn;
  gchar buffer[BUFFER_SIZE], data[BUFFER_SIZE];
  gchar *match,*value;
  gint bytes_read, active_index, pos=0;
  char message[256] = "";
  char *env[] = {"PATH=/usr/bin:/bin:./usr/local/bin:/bin", NULL};

  statusbar = lookup_widget (main_window, "statusbar1");
  //gtk_statusbar_pop (GTK_STATUSBAR (statusbar), 1);
  g_free (current_filename);
  current_filename = NULL;
  file_changed = FALSE;

  fpn = fopen (filename, "r");
  if (fpn == NULL)
    {
	  strcat (message, "echo \"\n\nERROR: Couldn't open Configuration File ");
	  strcat (message, filename);
	  strcat (message, " ... \n\"");
	  char *params_ok[] = {"/bin/sh", "-c", message ,NULL};
	  vte_terminal_fork_command ((VteTerminal*)statusbar,"sh", params_ok, env, NULL, FALSE, TRUE, TRUE);
      return;
    }

  for (;;)
    {
      bytes_read = fread (buffer, sizeof (gchar), BUFFER_SIZE, fpn);

      if (bytes_read > 0)
	{
	// si llegin quelcom
	
	}

      if (bytes_read != BUFFER_SIZE && (feof (fpn) || ferror (fpn)))
	break;
    }

  /* If there is an error while loading, we reset everything to a good state.
   */
  if (ferror (fpn))
    {
      fclose (fpn);
      set_window_title (main_window);
	  strcat (message, "echo \"\n\nERROR: Couldn't open Configuration File ");
	  strcat (message, filename);
	  strcat (message, " ... \n\"");
	  char *params_ok[] = {"/bin/sh", "-c", message ,NULL};
	  vte_terminal_fork_command ((VteTerminal*)statusbar,"sh", params_ok, env, NULL, FALSE, TRUE, TRUE);
      return;
    }

  fclose (fpn);

  /* Locate the line that includes the info.  */
  match = strstr (buffer, "server1:");
  if (match != NULL) {
    /* Parse the line to extrace the value.  */
    sscanf (match, "server1: %s\n", data);
    entry = lookup_widget(GTK_WIDGET(main_window), "entry39");
    gtk_editable_delete_text(GTK_EDITABLE(entry), 0, -1);
    gtk_editable_insert_text(GTK_EDITABLE(entry), data, strlen(data), &pos);
  }

  /* Locate the line that includes the info.  */
  match = strstr (buffer, "port1:");
  if (match != NULL) {
    /* Parse the line to extrace the value.  */
    sscanf (match, "port1: %s\n", data);
    entry = lookup_widget(GTK_WIDGET(main_window), "entry40");
    gtk_editable_delete_text(GTK_EDITABLE(entry), 0, -1);
    gtk_editable_insert_text(GTK_EDITABLE(entry), data, strlen(data), &pos);
  }

  /* Locate the line that includes the info.  */
  match = strstr (buffer, "mountpoint1:");
  if (match != NULL) {
    /* Parse the line to extrace the value.  */
    sscanf (match, "mountpoint1: %s\n", data);
    entry = lookup_widget(GTK_WIDGET(main_window), "entry41");
    gtk_editable_delete_text(GTK_EDITABLE(entry), 0, -1);
    gtk_editable_insert_text(GTK_EDITABLE(entry), data, strlen(data), &pos);
  }

  /* Locate the line that includes the info.  */
  match = strstr (buffer, "password1:");
  if (match != NULL) {
    /* Parse the line to extrace the value.  */
    sscanf (match, "password1: %s\n", data);
    entry = lookup_widget(GTK_WIDGET(main_window), "entry42");
    gtk_editable_delete_text(GTK_EDITABLE(entry), 0, -1);
    gtk_editable_insert_text(GTK_EDITABLE(entry), data, strlen(data), &pos);
  }

  /* Locate the line that includes the info.  */
  match = strstr (buffer, "framesize1:");
  if (match != NULL) {
    /* Parse the line to extrace the value.  */
    sscanf (match, "framesize1: %d\n", &active_index);
    entry = lookup_widget(GTK_WIDGET(main_window), "combobox7");
    gtk_combo_box_set_active(GTK_COMBO_BOX(entry),active_index);
  }

  /* Locate the line that includes the info.  */
  match = strstr (buffer, "framerate1:");
  if (match != NULL) {
    /* Parse the line to extrace the value.  */
    sscanf (match, "framerate1: %d\n", &active_index);
    entry = lookup_widget(GTK_WIDGET(main_window), "combobox6");
    gtk_combo_box_set_active(GTK_COMBO_BOX(entry),active_index);
  }

  /* Locate the line that includes the info.  */
  match = strstr (buffer, "vquality1:");
  if (match != NULL) {
    /* Parse the line to extrace the value.  */
    sscanf (match, "vquality1: %d\n", &active_index);
    entry = lookup_widget(GTK_WIDGET(main_window), "combobox5");
    gtk_combo_box_set_active(GTK_COMBO_BOX(entry),active_index);
  }

  /* Locate the line that includes the info.  */
  match = strstr (buffer, "aquality1:");
  if (match != NULL) {
    /* Parse the line to extrace the value.  */
    sscanf (match, "aquality1: %d\n", &active_index);
    entry = lookup_widget(GTK_WIDGET(main_window), "combobox4");
    gtk_combo_box_set_active(GTK_COMBO_BOX(entry),active_index);
  }

  /* Locate the line that includes the info.  */
  match = strstr (buffer, "achannels1:");
  if (match != NULL) {
    /* Parse the line to extrace the value.  */
    sscanf (match, "achannels1: %d\n", &active_index);
    entry = lookup_widget(GTK_WIDGET(main_window), "combobox3");
    gtk_combo_box_set_active(GTK_COMBO_BOX(entry),active_index);
  }

  /* Locate the line that includes the info.  */
  match = strstr (buffer, "samplerate1:");
  if (match != NULL) {
    /* Parse the line to extrace the value.  */
    sscanf (match, "samplerate1: %d\n", &active_index);
    entry = lookup_widget(GTK_WIDGET(main_window), "combobox2");
    gtk_combo_box_set_active(GTK_COMBO_BOX(entry),active_index);
  }

  /* Locate the line that includes the info.  */
  match = strstr (buffer, "artist1:");
  if (match != NULL) {
    /* Parse the line to extrace the value.  */
    sscanf (match, "artist1: %[^\n]s\n", data);
    entry = lookup_widget(GTK_WIDGET(main_window), "entry53");
    gtk_editable_delete_text(GTK_EDITABLE(entry), 0, -1);
    gtk_editable_insert_text(GTK_EDITABLE(entry), data, strlen(data), &pos);
  }

  /* Locate the line that includes the info.  */
  match = strstr (buffer, "title1:");
  if (match != NULL) {
    /* Parse the line to extrace the value.  */
    sscanf (match, "title1: %[^\n]s\n", data);
    entry = lookup_widget(GTK_WIDGET(main_window), "entry52");
    gtk_editable_delete_text(GTK_EDITABLE(entry), 0, -1);
    gtk_editable_insert_text(GTK_EDITABLE(entry), data, strlen(data), &pos);
  }

  /* Locate the line that includes the info.  */
  match = strstr (buffer, "date1:");
  if (match != NULL) {
    /* Parse the line to extrace the value.  */
    sscanf (match, "date1: %[^\n]s\n", data);
    entry = lookup_widget(GTK_WIDGET(main_window), "entry51");
    gtk_editable_delete_text(GTK_EDITABLE(entry), 0, -1);
    gtk_editable_insert_text(GTK_EDITABLE(entry), data, strlen(data), &pos);
  }

  /* Locate the line that includes the info.  */
  match = strstr (buffer, "location1:");
  if (match != NULL) {
    /* Parse the line to extrace the value.  */
    sscanf (match, "location1: %[^\n]s\n", data);
    entry = lookup_widget(GTK_WIDGET(main_window), "entry50");
    gtk_editable_delete_text(GTK_EDITABLE(entry), 0, -1);
    gtk_editable_insert_text(GTK_EDITABLE(entry), data, strlen(data), &pos);
  }

  /* Locate the line that includes the info.  */
  match = strstr (buffer, "organization1:");
  if (match != NULL) {
    /* Parse the line to extrace the value.  */
    sscanf (match, "organization1: %[^\n]s\n", data);
    entry = lookup_widget(GTK_WIDGET(main_window), "entry49");
    gtk_editable_delete_text(GTK_EDITABLE(entry), 0, -1);
    gtk_editable_insert_text(GTK_EDITABLE(entry), data, strlen(data), &pos);
  }

  /* Locate the line that includes the info.  */
  match = strstr (buffer, "copyright1:");
  if (match != NULL) {
    /* Parse the line to extrace the value.  */
    sscanf (match, "copyright1: %[^\n]s\n", data);
    entry = lookup_widget(GTK_WIDGET(main_window), "entry48");
    gtk_editable_delete_text(GTK_EDITABLE(entry), 0, -1);
    gtk_editable_insert_text(GTK_EDITABLE(entry), data, strlen(data), &pos);
  }

  /* Locate the line that includes the info.  */
  match = strstr (buffer, "license1:");
  if (match != NULL) {
    /* Parse the line to extrace the value.  */
    sscanf (match, "license1: %[^\n]s\n", data);
    entry = lookup_widget(GTK_WIDGET(main_window), "entry47");
    gtk_editable_delete_text(GTK_EDITABLE(entry), 0, -1);
    gtk_editable_insert_text(GTK_EDITABLE(entry), data, strlen(data), &pos);
  }

  /* Locate the line that includes the info.  */
  match = strstr (buffer, "description1:");
  if (match != NULL) {
    /* Parse the line to extrace the value.  */
    sscanf (match, "description1: %[^\n]s\n", data);
    entry = lookup_widget(GTK_WIDGET(main_window), "entry46");
    gtk_editable_delete_text(GTK_EDITABLE(entry), 0, -1);
    gtk_editable_insert_text(GTK_EDITABLE(entry), data, strlen(data), &pos);
  }

  /* Locate the line that includes the info.  */
  match = strstr (buffer, "genre1:");
  if (match != NULL) {
    /* Parse the line to extrace the value.  */
    sscanf (match, "genre1: %[^\n]s\n", data);
    entry = lookup_widget(GTK_WIDGET(main_window), "entry45");
    gtk_editable_delete_text(GTK_EDITABLE(entry), 0, -1);
    gtk_editable_insert_text(GTK_EDITABLE(entry), data, strlen(data), &pos);
  }

  /* Locate the line that includes the info.  */
  match = strstr (buffer, "name1:");
  if (match != NULL) {
    /* Parse the line to extrace the value.  */
    sscanf (match, "name1: %[^\n]s\n", data);
    entry = lookup_widget(GTK_WIDGET(main_window), "entry44");
    gtk_editable_delete_text(GTK_EDITABLE(entry), 0, -1);
    gtk_editable_insert_text(GTK_EDITABLE(entry), data, strlen(data), &pos);
  }

  /* Locate the line that includes the info.  */
  match = strstr (buffer, "url1:");
  if (match != NULL) {
    /* Parse the line to extrace the value.  */
    sscanf (match, "url1: %s\n", data);
    entry = lookup_widget(GTK_WIDGET(main_window), "entry43");
    gtk_editable_delete_text(GTK_EDITABLE(entry), 0, -1);
    gtk_editable_insert_text(GTK_EDITABLE(entry), data, strlen(data), &pos);
  }
  
  current_filename = g_strdup (filename);
  set_window_title (main_window);
  strcat (message, "echo \"\n\nConfiguration File ");
  strcat (message, filename);
  strcat (message, " correctly loaded ... \n\"");
  char *params_ok[] = {"/bin/sh", "-c", message ,NULL};
  vte_terminal_fork_command ((VteTerminal*)statusbar,"sh", params_ok, env, NULL, FALSE, TRUE, TRUE);
}


/* This saves the file, which is in on-disk encoding (which may not be UTF-8). */
static void
real_save_file (GtkWidget *main_window, const gchar *filename)
{
  GtkWidget *entry, *statusbar;
  gchar *data;
  FILE *fp2;
  gint bytes_written, len, active_index;
  char *env[] = {"PATH=/usr/bin:/bin:./usr/local/bin:/bin", NULL};
  char message[256] = "";


  if (current_filename == NULL || strcmp (current_filename, filename))
    {
      g_free (current_filename);
      current_filename = g_strdup (filename);
      set_window_title (main_window);
    }

  statusbar = lookup_widget (main_window, "statusbar1");


  fp2 = fopen (filename, "w");
  if (fp2 == NULL)
    {
      return;
    }

  entry = lookup_widget(GTK_WIDGET(main_window), "entry39");
  data = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
  fprintf(fp2,"server1: %s\n",data);

  entry = lookup_widget(GTK_WIDGET(main_window), "entry40");
  data = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
  fprintf(fp2,"port1: %s\n",data);

  entry = lookup_widget(GTK_WIDGET(main_window), "entry41");
  data = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
  fprintf(fp2,"mountpoint1: %s\n",data);

  entry = lookup_widget(GTK_WIDGET(main_window), "entry42");
  data = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
  fprintf(fp2,"password1: %s\n",data);
		
  entry = lookup_widget (GTK_WIDGET (main_window), "combobox7");
  active_index = gtk_combo_box_get_active(GTK_COMBO_BOX(entry));
  fprintf(fp2,"framesize1: %d\n",active_index);
		
  entry = lookup_widget (GTK_WIDGET (main_window), "combobox6");
  active_index = gtk_combo_box_get_active(GTK_COMBO_BOX(entry));
  fprintf(fp2,"framerate1: %d\n",active_index);
		
  entry = lookup_widget (GTK_WIDGET (main_window), "combobox5");
  active_index = gtk_combo_box_get_active(GTK_COMBO_BOX(entry));
  fprintf(fp2,"vquality1: %d\n",active_index);
		
  entry = lookup_widget (GTK_WIDGET (main_window), "combobox4");
  active_index = gtk_combo_box_get_active(GTK_COMBO_BOX(entry));
  fprintf(fp2,"aquality1: %d\n",active_index);
		
  entry = lookup_widget (GTK_WIDGET (main_window), "combobox3");
  active_index = gtk_combo_box_get_active(GTK_COMBO_BOX(entry));
  fprintf(fp2,"achannels1: %d\n",active_index);
		
  entry = lookup_widget (GTK_WIDGET (main_window), "combobox2");
  active_index = gtk_combo_box_get_active(GTK_COMBO_BOX(entry));
  fprintf(fp2,"samplerate1: %d\n",active_index);

  entry = lookup_widget(GTK_WIDGET(main_window), "entry53");
  data = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
  fprintf(fp2,"artist1: %s\n",data);

  entry = lookup_widget(GTK_WIDGET(main_window), "entry52");
  data = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
  fprintf(fp2,"title1: %s\n",data);

  entry = lookup_widget(GTK_WIDGET(main_window), "entry51");
  data = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
  fprintf(fp2,"date1: %s\n",data);

  entry = lookup_widget(GTK_WIDGET(main_window), "entry50");
  data = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
  fprintf(fp2,"location1: %s\n",data);

  entry = lookup_widget(GTK_WIDGET(main_window), "entry49");
  data = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
  fprintf(fp2,"organization1: %s\n",data);

  entry = lookup_widget(GTK_WIDGET(main_window), "entry48");
  data = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
  fprintf(fp2,"copyright1: %s\n",data);

  entry = lookup_widget(GTK_WIDGET(main_window), "entry47");
  data = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
  fprintf(fp2,"license1: %s\n",data);

  entry = lookup_widget(GTK_WIDGET(main_window), "entry46");
  data = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
  fprintf(fp2,"description1: %s\n",data);

  entry = lookup_widget(GTK_WIDGET(main_window), "entry45");
  data = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
  fprintf(fp2,"genre1: %s\n",data);

  entry = lookup_widget(GTK_WIDGET(main_window), "entry44");
  data = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
  fprintf(fp2,"name1: %s\n",data);

  entry = lookup_widget(GTK_WIDGET(main_window), "entry43");
  data = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
  fprintf(fp2,"url1: %s\n",data);

  entry = lookup_widget(GTK_WIDGET(main_window), "entry80");
  data = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
  fprintf(fp2,"dump1: %s\n",data);
  
  
  
  
  fclose (fp2);

  g_free (data);

  if (len != bytes_written)
    {
	  strcat (message, "echo \"\n\nERROR: Couldn't open Configuration File ");
	  strcat (message, filename);
	  strcat (message, " ... \n\"");
	  char *params[] = {"/bin/sh", "-c", message ,NULL};
	  vte_terminal_fork_command ((VteTerminal*)statusbar,"sh", params, env, NULL, FALSE, TRUE, TRUE);
      return;
    }

  file_changed = FALSE;
  strcat (message, "echo \"\n\nConfiguration File ");
  strcat (message, filename);
  strcat (message, " correctly saved ... \n\"");
  char *params_saved[] = {"/bin/sh", "-c", message ,NULL};
  vte_terminal_fork_command ((VteTerminal*)statusbar,"sh", params_saved, env, NULL, FALSE, TRUE, TRUE);
}


void
on_button9_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *main_window;

  main_window = lookup_widget (GTK_WIDGET (button), "window1");
  open_infile (main_window);

}



void
on_button10_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_hide (gtk_widget_get_toplevel (GTK_WIDGET (button)));

}


void
on_button11_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *filesel, *main_window;
  const gchar *filename;

  filesel = gtk_widget_get_toplevel (GTK_WIDGET (button));
  main_window = gtk_object_get_data (GTK_OBJECT (filesel), MainWindowKey);
  if (gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (filesel)) != NULL ) {
	  gtk_widget_hide (filesel);
	  filename = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (filesel));
	  real_open_infile (main_window, filename);
  }

}


void
on_window1_destroy                     (GtkObject       *object,
                                        gpointer         user_data)
{
 system ("rm /tmp/tssSTREAM > /dev/null 2>&1");
 exit (0);
}


void
on_window1_show                        (GtkWidget       *widget,
                                        gpointer         user_data)
{
  GtkWidget *main_window, *entry;

  //fprintf(stderr,"on_window1_show\n");
  main_window = gtk_widget_get_toplevel (GTK_WIDGET (widget));

    entry = lookup_widget(GTK_WIDGET(main_window), "combobox1");
    gtk_combo_box_set_active(GTK_COMBO_BOX(entry),0);
    //entry = lookup_widget(GTK_WIDGET(main_window), "combobox14");
    //gtk_combo_box_set_active(GTK_COMBO_BOX(entry),1);
    //entry = lookup_widget(GTK_WIDGET(main_window), "combobox15");
    //gtk_combo_box_set_active(GTK_COMBO_BOX(entry),0);
	
    entry = lookup_widget (GTK_WIDGET (main_window), "checkbutton3");
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(entry),1);


  real_open_file (main_window, "/usr/local/share/tss/defaultsettings");
 
}


void
on_button3_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *main_window;

  main_window = lookup_widget (GTK_WIDGET (button), "window1");

  if (save_outfile1sel == NULL)
    {
      save_outfile1sel = create_filechooserdialog4 ();
      /* Make sure the dialog doesn't disappear behind the main window. */
      gtk_window_set_transient_for (GTK_WINDOW (save_outfile1sel), 
				    GTK_WINDOW (main_window));
    }

  gtk_object_set_data (GTK_OBJECT (save_outfile1sel), MainWindowKey, main_window);

  /* We make sure the dialog is visible. */
  gtk_window_present (GTK_WINDOW (save_outfile1sel));

}


void
on_button4_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *main_window;

  main_window = lookup_widget (GTK_WIDGET (button), "window1");

  if (save_outfile2sel == NULL)
    {
      save_outfile2sel = create_filechooserdialog5 ();
      /* Make sure the dialog doesn't disappear behind the main window. */
      gtk_window_set_transient_for (GTK_WINDOW (save_outfile2sel), 
				    GTK_WINDOW (main_window));
    }

  gtk_object_set_data (GTK_OBJECT (save_outfile2sel), MainWindowKey, main_window);

  /* We make sure the dialog is visible. */
  gtk_window_present (GTK_WINDOW (save_outfile2sel));

}


void
on_button13_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *filesel, *main_window, *entry;
  const gchar *filename;
  gint pos=0;

  filesel = gtk_widget_get_toplevel (GTK_WIDGET (button));
  main_window = gtk_object_get_data (GTK_OBJECT (filesel), MainWindowKey);
  if (gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (filesel)) != NULL ) {
  	gtk_widget_hide (filesel);
  	filename = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (filesel));

    	entry = lookup_widget(GTK_WIDGET(main_window), "entry80");
    	gtk_editable_delete_text(GTK_EDITABLE(entry), 0, -1);
    	gtk_editable_insert_text(GTK_EDITABLE(entry), filename, strlen(filename), &pos);
  }
}


void
on_button15_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *filesel, *main_window, *entry;
  const gchar *filename;
  gint pos=0;

  filesel = gtk_widget_get_toplevel (GTK_WIDGET (button));
  main_window = gtk_object_get_data (GTK_OBJECT (filesel), MainWindowKey);
  if (gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (filesel)) != NULL ) {
  	gtk_widget_hide (filesel);
  	filename = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (filesel));

    	entry = lookup_widget(GTK_WIDGET(main_window), "entry81");
    	gtk_editable_delete_text(GTK_EDITABLE(entry), 0, -1);
    	gtk_editable_insert_text(GTK_EDITABLE(entry), filename, strlen(filename), &pos);
  }
}


void
on_button12_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_hide (gtk_widget_get_toplevel (GTK_WIDGET (button)));

}


void
on_button14_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_hide (gtk_widget_get_toplevel (GTK_WIDGET (button)));

}

